// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

class Runtime;
class Scheduler;
class Dispatcher;
class RuntimeStrategyStats;

#include <memory>

class RuntimeStrategy {
	friend class Runtime;

 private:
	virtual auto getScheduler(Runtime& runtime) -> Scheduler& = 0;

	virtual auto getDispatcher(Runtime& runtime) -> Dispatcher& = 0;

 public:
	virtual auto getStats() -> std::shared_ptr<RuntimeStrategyStats> = 0;
};
