// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "Semaphore.hpp"

#include <iostream>	 // for operator<<, basic_ostream, basic_o...

#include "lib/sync/Semaphore.hpp"	 // for emper

using namespace emper;

void Semaphore::print() {
	unsigned int count = this->count;
	unsigned int waiterListSize;
	{
		const std::lock_guard<std::mutex> lock(mutex);
		waiterListSize = waiterList.size();
	}

	std::cout << "Semaphore"
						<< " count=" << count << " waiterListSize=" << waiterListSize << std::endl;
}
