// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include "emper-common.h"

typedef struct runtime runtime;	 // NOLINT(modernize-use-using)

typedef struct fiber fiber;	 // NOLINT(modernize-use-using)

typedef struct bps bps;	 // NOLINT(modernize-use-using)

typedef struct cps cps;	 // NOLINT(modernize-use-using)

#ifdef __cplusplus
extern "C" {
#endif

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
runtime* init_runtime(void);

void wait_until_runtime_finished();

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
fiber* fiber_from(void (*function)(void*), void* arg);

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
fiber* fiber_from0(void (*function)());

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
fiber* aff_fiber_from(void (*function)(void*), void* arg, workeraffinity_t* affinity);

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
fiber* aff_fiber_from0(void (*function)(), workeraffinity_t* affinity);

void init_affinity(workeraffinity_t affinity[], unsigned int n);

void schedule(fiber* fiber);

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
bps* new_binary_sem(void);

void signal_bps(bps* sem);

void signal_and_exit_bps(bps* sem);

void wait_bps(bps* sem);

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
cps* new_counting_sem(void);

// NOLINTNEXTLINE(modernize-use-trailing-return-type)
cps* new_counting_sem_with(unsigned int i);

void signal_cps(cps* sem);

void signal_and_exit_cps(cps* sem);

void wait_cps(cps* sem);

#ifdef __cplusplus
}
#endif
