// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "LawsStrategy.hpp"

#include "strategies/laws/LawsDispatcher.hpp"			// for LawsDispatcher
#include "strategies/laws/LawsScheduler.hpp"			// for LawsScheduler
#include "strategies/laws/LawsStrategyStats.hpp"	// for LawsStrategyStats

LawsStrategy LawsStrategy::INSTANCE;

auto LawsStrategy::getScheduler(Runtime& runtime) -> Scheduler& {
	Scheduler* scheduler = new LawsScheduler(runtime, *this);
	return *scheduler;
}

auto LawsStrategy::getDispatcher(Runtime& runtime) -> Dispatcher& {
	Dispatcher* dispatcher = new LawsDispatcher(runtime, *this);
	return *dispatcher;
}

auto LawsStrategy::getStats() -> std::shared_ptr<RuntimeStrategyStats> {
	return std::make_shared<LawsStrategyStats>(*this);
}
