// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include <cstdint>

#include "RuntimeStrategyStats.hpp"

class LawsStrategy;

class LawsStrategyStats : public RuntimeStrategyStats {
 private:
	const uint64_t scheduledFibersToRemotePriority;
	const uint64_t scheduledFibersToLocal;
	const uint64_t dispatchedFiberFromPriority;
	const uint64_t dispatchedFiberFromLocal;
	const uint64_t dispatchedFiberStolen;
	const uint64_t dispatchedFiberFromMainThread;

 public:
	LawsStrategyStats(LawsStrategy& lawsStrategy);

	[[nodiscard]] auto getScheduledFibersToRemotePriority() const -> uint64_t;
	[[nodiscard]] auto getScheduledFibersToLocal() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromPriority() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromLocal() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberStolen() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromMainThread() const -> uint64_t;

	void print() override;
};
