// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include <cstdint>

#include "RuntimeStrategyStats.hpp"

class WsStrategy;

class WsStrategyStats : public RuntimeStrategyStats {
 private:
	const uint64_t scheduledFibers;
	const uint64_t nextFiberFromLocal;
	const uint64_t nextFiberStolen;

 public:
	WsStrategyStats(WsStrategy& wsStrategy);

	[[nodiscard]] auto getScheduledFibers() const -> uint64_t;
	[[nodiscard]] auto getNextFiberFromLocal() const -> uint64_t;
	[[nodiscard]] auto getNextFiberStolen() const -> uint64_t;

	void print() override;
};
